module SearchyJson
  class Service
    attr_reader :data_path, :primary_key, :search_fields

    def initialize(data_path:, primary_key:, search_fields: [])
      @data_path = data_path
      @primary_key = primary_key
      @search_fields = search_fields
    end

    def find(query)
      search_query = SearchyJson::Query.new(query)
      Extracter.new(search_data, search_query).call
    end

    private

    def search_data
      @search_data ||= SearchyJson::Data.new(data_path, primary_key: primary_key, search_fields: search_fields).call
    end
  end
end
